

/* Il carico della CPU sul K6-2 333MHz e` inferiore all'1% */



#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include <X11/Xlib.h>

#define world_width 600
#define world_height 400
#define world_widthd 360.0
#define world_heightd 180.0

#define MAPWIDTH     (unsigned int) world_width           /* [pixels]     */
#define MAPHEIGHT    (unsigned int) world_height          /* [pixels]     */
#define MAPTYPE      (unsigned int) world_type            /* 1 or 2       */
#define MAPWIDTHD    (double) world_widthd                /* [deg]        */
#define MAPHEIGHTD   (double) world_heightd               /* [deg]        */

Display      *display;
Window       window, root_win;
GC           gc;
Colormap     colormap;
XColor       color;
Drawable     drawable,  sat;
Widget       toplevel, frame;
XtAppContext appcontext;
Arg          warg[3];
Pixmap       pixmap, wmap;

char         initflag=0;

int screen;
char appname[80];
unsigned long numcolors, colorBLACK, colorWHITE, colorSEA, colorGND, colorLAKE,
  colorFOOTPRINT, colorSATNAME;


void createcolors(void), drawmap(void), drawsat(float, float);


int main(int argc, char** argv){
float lon, lat, t;


  display = XOpenDisplay(":0");
  if (display == NULL) {
    fprintf(stderr, "cannot connect to X server \n");
    return(1);
  }

  root_win=RootWindow(display, DefaultScreen(display));

  createcolors();

  window=XCreateSimpleWindow(display, root_win, 
			     0, 0,
			     MAPWIDTH, MAPHEIGHT,
			     10,
			     colorGND, colorSEA
			     );
  XMapWindow(display, window);  
  XFlush(display);

  gc=XCreateGC(display, window, 0, 0);

  drawmap();
  XCopyArea(display, wmap, window, gc, 0, 0, MAPWIDTH, MAPHEIGHT, 0, 0);
  XFlush(display);
  sleep(1);


  t=0.;
  while(1){
    t+=M_PI/64; if(t>2*M_PI) t=0.;
    lon=180*cos(t);
    lat=90*sin(3*t);

    drawsat(lon, lat);
    usleep(50000);
  }



  XCloseDisplay(display);
  return 0;
}


void drawmap(void){
XPoint *vertex;
FILE *mfd;
long int l, ml;
double x, y;
char b[80];

 wmap=XCreatePixmap(display, DefaultRootWindow(display), MAPWIDTH, MAPHEIGHT, 
		    DefaultDepth(display, DefaultScreen(display)));

 XSetLineAttributes(display, gc,
		    1, LineSolid, CapButt, JoinBevel);
 
 XSetForeground(display, gc, colorSEA);
 XFillRectangle(display, wmap, gc, 0, 0, MAPWIDTH, MAPHEIGHT);

 if((mfd=fopen("wmap.dat", "r"))==NULL) 
   { printf("Unable to find map file\n"); return; }
 
 ml=-1; l=0;
 do{
   fgets(b, 80, mfd);
   if(b[0]=='T' || b[0]=='L') { if(l>ml) {ml=l;  l=0;} }
   else l++;
 }while(!feof(mfd));

 printf("max block lenght %ld\n", ml);
 
 if((vertex=(XPoint*) calloc(ml, sizeof(XPoint)))==NULL)
   { printf("Unable to allocate memory for map data\n"); return; }
 
 rewind(mfd);
 
 
 l=0; XSetForeground(display, gc, colorGND);
 do{
   fgets(b, 80, mfd);
   if(b[0]=='T' && l!=0){
     XFillPolygon(display, wmap, gc, vertex, l, Nonconvex, CoordModeOrigin);
     l=0;
   }
   else if(b[0]=='L') { l=0; continue; }
   else {
     sscanf(b, "%lf %lf", &x, &y);
     vertex[l].x=((float)x/360.+.5)*MAPWIDTH; 
     vertex[l].y=(.5-(float)y/180.)*MAPHEIGHT;
     l++;
   }
 }while(!feof(mfd));
 
 rewind(mfd);
 
 l=0; XSetForeground(display, gc, colorLAKE);
 do{
   fgets(b, 80, mfd);
   if(b[0]=='L' && l!=0){
     XFillPolygon(display, wmap, gc, vertex, l, Nonconvex, CoordModeOrigin);
     l=0;
   }
   else if(b[0]=='T') { l=0; continue; }
   else {
     sscanf(b, "%lf %lf", &x, &y);
     vertex[l].x=((float)x/360.+.5)*MAPWIDTH; 
     vertex[l].y=(.5-(float)y/180.)*MAPHEIGHT;
     l++;
   }
 }while(!feof(mfd));
 fclose(mfd);
 
 free(vertex);
}


void drawsat(float lon, float lat){
int x, y;
  
 XCopyArea(display, wmap, window, gc, 0, 0, MAPWIDTH, MAPHEIGHT, 0, 0);

 x=(lon/360.+.5)*MAPWIDTH;
 y=(.5-lat/180.)*MAPHEIGHT;

 XSetForeground(display, gc, colorFOOTPRINT);
 XDrawArc(display, window, gc, x-20, y-20, 40, 40, 0, 360*64);


 /* La scritta non viene centrata, usare la XTextWidth() */
 XSetForeground(display, gc, colorSATNAME);
 XDrawString(display, window, gc, x, y, "SAT", 3);
 XFlush(display);

}


void createcolors(void){
  
  colormap=DefaultColormap(display, screen);
  color.flags=DoRed|DoGreen|DoBlue;
  
  /* black */
  color.red=0; color.green=0; color.blue=0;
  XAllocColor(display, colormap, &color);
  colorBLACK=color.pixel;
  
  /* white */
  color.red=65535; color.green=65535; color.blue=65535;
  XAllocColor(display, colormap, &color);
  colorWHITE=color.pixel;
  
  /* sea */
  color.red=0; color.green=1000; color.blue=50000;
  XAllocColor(display, colormap, &color);
  colorSEA=color.pixel;
  
  /* ground */
  color.red=1000; color.green=50000; color.blue=0;
  XAllocColor(display, colormap, &color);
  colorGND=color.pixel;
  
  /* lake */
  color.red=0; color.green=1000; color.blue=40000;
  XAllocColor(display, colormap, &color);
  colorLAKE=color.pixel;

  /* footprint */
  color.red=40000; color.green=0; color.blue=20000;
  XAllocColor(display, colormap, &color);
  colorFOOTPRINT=color.pixel;

  /* satellite name */
  color.red=60000; color.green=20000; color.blue=0;
  XAllocColor(display, colormap, &color);
  colorSATNAME=color.pixel;
}
